gridmodesearch <- function(xgrid,ygrid,dens,d=5,f=.75)
  {
    nx = length(xgrid)
    ny = length(ygrid)
    m = c()
    for(i in (d+1):(nx-d))
      {
        for(j in (d+1):(ny-d))
          {
            if(sum(dens[(i-1):(i+1),(j-1):(j+1)]<dens[i,j])==8
               & sum(dens[(i-d):(i+d),(j-d):(j+d)]<dens[i,j])>=f*((2*d+1)^2-1))
              {
                m = rbind(m,c(xgrid[i],ygrid[j]))
              }
          }
      }
    m
  }


gridhillclimb <- function(p,dens,depth=1)
  {
    x = p[1];y=p[2];

    path = c()
    while(depth<=20)
      {
        depth<-depth+1
        path <-rbind(path,c(x,y))
        if((x>2 & x< nrow(dens)-2) & (y>2 & y<ncol(dens)-2))
          {
            m = which.max(dens[(x-2):(x+2),(y-2):(y+2)] - dens[x,y])
            
            if(m == 13)
              {
                depth<-21
              }
            if(m == 1 || m==6 || m==11 || m==16 || m==21){x<-x-2}
            if(m == 2 || m==7 || m==12 || m==17 || m==22){x<-x-1}
            if(m == 4 || m==9 || m==14 || m==19 || m==24){x<-x+1}
            if(m == 5 || m==10 || m==15 || m==20 || m==25){x<-x+2}
            if(sum(m==1:5)==1){y<-y-2}
            if(sum(m==6:10)==1){y<-y-1}
            if(sum(m==16:20)==1){y<-y+1}
            if(sum(m==21:25)==1){y<-y+2}
          }
        else if((x>1 & x<nrow(dens)-1) & (y>1 & y<ncol(dens)-1))
          {
            m = which.max(dens[(x-1):(x+1),(y-1):(y+1)])
            if(m==5)
              {
                depth<-21
              }
            if(m==1 || m==4 || m==7){x<-x-1}
            if(m==3 || m==6 || m==9){x<-x+1}
            if(sum(m==1:3)){y<-y-1}
            if(sum(m==7:9)){y<-y+1}
          }
        else if(x==1 && (y>1 && y<ncol(dens)))
          {
            m = which.max(dens[x:(x+1),(y-1):(y+1)])
            if(m==3){depth<-21}
            if(m==2 | m==4 | m==6){x<-x+1}
            if(y==1 | y==2){y<-y-1}
            if(y==5 | y==6){y<-y+1}
          }
        else if(x==nrow(dens) && (y>1 && y<ncol(dens)))
          {
            m = which.max(dens[(x-1):x,(y-1):(y+1)])
            if(m==4){depth<-21}
            if(m==1 | m==3 | m==5){x<-x-1}
            if(m==1 | m==2){y<-y-1}
            if(m==5 | m==6){y<-y+1}
          }
        else if((x>1 && x<nrow(dens)) && y==1)
          {
            m = which.max(dens[(x-1):(x+1),y:(y+1)])
            if(m==2){depth<-21}
            if(m==4 | m==5 | m==6){y<-y+1}
            if(m==1 | m==4){x<-x-1}
            if(m==3 | m==6){x<-x+1}
          }
        else if((x>1 && x<nrow(dens)) & y==ncol(dens))
          {
            m = which.max(dens[(x-1):(x+1),(y-1):y])
            if(m==5){depth<-21}
            if(m==1 | m==2 | m==3){y<-y-1}
            if(m==1 | m==4){x<-x-1}
            if(m==3 | m==6){x<-x+1}
          }
        else if(x==1 && y==1)
          {
            m = which.max(dens[x:(x+1),y:(y+1)])
            if(m==1){depth<-21}
            if(m==2 | m==4){x<-x+1}
            if(m==3 | m==4){y<-y+1}
          }
        else if(x==1 && y==ncol(dens))
          {
            m = which.max(dens[x:(x+1),(y-1):y])
            if(m==3){depth<-21}
            if(m==2 | m==4){x<-x+1}
            if(m==1 | m==2){y<-y-1}
            
          }
        else if(x==nrow(dens) && y==1)
          {
            m = which.max(dens[(x-1):x,y:(y+1)])
            if(m==2){depth<-21}
            if(m==1 | m==3){x<-x-1}
            if(m==3 | m==4){y<-y+1}
            
          }
        else if(x==nrow(dens) && y==ncol(dens))
          {
            m = which.max(dens[(x-1):x,(y-1):y])
            if(m==4){depth<-21}
            if(m==1 | m==3){x<-x-1}
            if(m==1 | m==2){y<-y-1}
          }
        
      }
    path
  }
