
#ifndef __linalg_h__
#define __linalg_h__

#ifndef CBLAS_ENUM_DEFINED_H
   #define CBLAS_ENUM_DEFINED_H
   enum CBLAS_ORDER {CblasRowMajor=101, CblasColMajor=102 };
   enum CBLAS_TRANSPOSE {CblasNoTrans=111, CblasTrans=112, CblasConjTrans=113, AtlasConj=114};
   enum CBLAS_UPLO  {CblasUpper=121, CblasLower=122};
   enum CBLAS_DIAG  {CblasNonUnit=131, CblasUnit=132};
   enum CBLAS_SIDE  {CblasLeft=141, CblasRight=142};
#endif


#define dgetri dgetri_
extern void dgetri(int*, double*, int*, int*, double*, int*, int*);
void my_dgetri(int n, double** A, int lda, int* ipiv, double* work, int lwork, int* info);
//void R_dgetri(int* n, double* A, int* lda, int* ipiv, double* work, int* lwork, int* info);

#define dgetrf dgetrf_
extern void dgetrf(int*,int*,double*,int*,int*,int*);
void my_dgetrf(int m,int n, double** A,int lda,int* ipiv,int* info);

void R_invertmatrix(double *A, int* dim);
void my_invert_matrix(double **A, int dim);


#define dpotrf dpotrf_
extern void dpotrf(char*, int*, double*, int*, int*);
int my_dpotrf(double** cov, int n);

#define dgemm dgemm_
extern void dgemm(char*, char*, int*,int*, int*, double*,
		  double*, int*, double*, int*, double*, double*, int*);
void my_dgemm(const enum CBLAS_TRANSPOSE TA, const enum CBLAS_TRANSPOSE TB, 
	      int m, int n, int k, double alpha, double** A, int lda, 
	      double** B, int ldb, double beta, double** C, int ldc);

#define dgemv dgemv_
extern void dgemv(char*, int*, int*, double*, double*, int*, 
                  double*, int*, double*, double*, int*);
void my_dgemv(const enum CBLAS_TRANSPOSE TA, 
		int m, int n, double alpha, double **A, int lda, 
		double *X, int ldx, double beta, double *Y, int ldy);

#define ddot ddot_
extern double ddot(int*, double*, int*, double*, int*);
double my_ddot(int n, double *X, int ldx, double *Y, int ldy);

double my_det(double** cov, int dim, int logspace);

void my_chol(double** cov, int n);

void R_chol(double* cov, int* dim);

void R_dgemm(char** ta, char** tb, int* m, int* n, int* k, double* alpha, double* A, int* lda, double* B, int* ldb, double* beta, double* C, int* ldc);

void R_mymatmult(double *A, int* nrowa, int* ncola, int* transa,
		 double *B, int* nrowb, int* ncolb, int* transb,
		 double* C);

void my_matrix_multiply(double** A, int nrowa, int ncola, int transa, 
			double** B, int nrowb, int ncolb, int transb,
			double** C);

#define daxpy daxpy_
extern void daxpy(int*, double*, double*, int*, double*, int*);
void my_daxpy(int n, double alpha, double *X, int ldx, double *Y, int ldy);

#define dtrsv dtrsv_
extern void dtrsv(char*, char*, char*, int*, double*, int*, double*, int*);
void my_dtrsv(const enum CBLAS_TRANSPOSE TA, int n, double **A, int lda, double *Y, int ldy);

/* #define dsymm dsymm_ */
/* extern void dsymm(char*, char*, int*, int*, double*, */
/* 		  double*, int*, double*, int*, double*, double*, int*); */
/* void my_dsymm(const enum CBLAS_SIDE side, */
/* 		int m, int n, double alpha, double **A, int lda, double **B,  */
/* 		int ldb, double beta, double **C, int ldc); */

#endif
